Index: src/org/armedbear/lisp/sort.lisp
===================================================================
--- src/org/armedbear/lisp/sort.lisp	(revision 13835)
+++ src/org/armedbear/lisp/sort.lisp	(working copy)
@@ -42,7 +42,10 @@
 (defun stable-sort (sequence predicate &rest args &key key)
   (sequence::seq-dispatch sequence
     (sort-list sequence predicate key)
-    (quick-sort sequence 0 (length sequence) predicate key)
+    (coerce (sort-list (coerce sequence 'list) 
+		       predicate
+		       key)
+	    (type-of sequence))
     (apply #'sequence:stable-sort sequence predicate args)))
 
 ;; Adapted from SBCL.
